function z = DivDiff(x,y)
% DivDiff
% Recursive implementation of divided differences. Slow.
%
% Example
% x = linspace(-pi,pi,10);
% y = sin(x);
% DivDiff(x,y)
%
% See also DivDiffTable

% Copyright 2011 Laurent Hoeltgen <hoeltgman@gmail.com>
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
% MA 02110-1301, USA.

assert(isequal(size(x),size(y)));
if length(x)==2
    z = (y(2)-y(1))/(x(2)-x(1));
else
    z = (DivDiff(x(2:end),y(2:end))-DivDiff(x(1:end-1),y(1:end-1)))/(x(end)-x(1));
end
end