function F = DivDiffTable(x,y)
% DivDiffTable
% Compute all the divided differences. Fast but memory exhaustive.
%
% Example
% x = linspace(-pi,pi,10);
% y = sin(x);
% DivDiffTable(x,y)
%
% See also DivDiff

% Copyright 2011 Laurent Hoeltgen <hoeltgman@gmail.com>
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
% MA 02110-1301, USA.

n = length(x);
F = zeros(n,n);
F(:,1) = y;
for j = 2:n
    for i = j:n
        F(i,j) = (F(i,j-1)-F(i-1,j-1))/(x(i)-x(i-j+1));
    end
end
end