function y = KeysFunction(x,a)
% KeysFunction
% Keys Function with parameter a for interpolation.
%
% Example
% KeysFunction([-10:10],-0.5)
%
% See also ClassicInterpolation

% Copyright 2011, 2012, 2013 Laurent Hoeltgen <hoeltgman@gmail.com>
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
% MA 02110-1301, USA.

% Last revision on: 24.04.2013 09:55

narginchk(2,2);
nargoutchk(0,1);

y = (abs(x)<1).*( (a+2).*abs(x).^3-(a+3).*abs(x).^2+1 ) + ...
    (abs(x)>=1).*(abs(x)<2).*( a.*abs(x).^3-5*a.*abs(x).^2+8*a.*abs(x)-4*a );
end
